//**********************
// DAC header
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************

#ifndef __DAC_H
#define __DAC_H

#define PORT0		0
#define PORT1		1
#define PORT2		2
#define PORT3		3

#define DAC_nMS_L	GPIOSetValue(PORT3, 0, OUTPUT_OFF)
#define DAC_nMS_H	GPIOSetValue(PORT3, 0, OUTPUT_ON)
#define DAC_MDI_L	GPIOSetValue(PORT3, 1, OUTPUT_OFF)
#define DAC_MDI_H	GPIOSetValue(PORT3, 1, OUTPUT_ON)
#define DAC_MC_L	GPIOSetValue(PORT1, 3, OUTPUT_OFF)
#define DAC_MC_H	GPIOSetValue(PORT1, 3, OUTPUT_ON)
#define DAC_nRST_L	GPIOSetValue(PORT1, 11, OUTPUT_OFF)
#define DAC_nRST_H	GPIOSetValue(PORT1, 11, OUTPUT_ON)
#define DAC_MDOI	(LPC_GPIO1->DATA&0x10)

#define	DAC_nMS_OUT	GPIOSetDir(PORT3,0, 1)
#define	DAC_MDI_OUT	GPIOSetDir(PORT3,1, 1)
#define	DAC_MC_OUT	GPIOSetDir(PORT1,3, 1)
#define	DAC_nRST_OUT	GPIOSetDir(PORT1,11, 1)
#define	DAC_MDO_IN	GPIOSetDir(PORT1,4, 0)

// PORT1_3
#define IOCON_SWDIO_PIO1_3                        (*((unsigned int *) (0x40044090)))
#define IOCON_SWDIO_PIO1_3_FUNC_GPIO              ((unsigned int) 0x00000001)
#define IOCON_SWDIO_PIO1_3_MODE_PULLUP  	      ((unsigned int) 0x00000010)
#define IOCON_SWDIO_PIO1_3_ADMODE_DIGITAL         ((unsigned int) 0x00000080)


// PCM1795
#define RESISTER16	0x10
#define RESISTER17	0x11
#define RESISTER18	0x12
#define RESISTER19	0x13
#define RESISTER20	0x14
#define RESISTER21	0x15
#define RESISTER22	0x16
#define RESISTER23	0x17


void InitDAC();
void WriteDAC(unsigned char a, unsigned char d);
unsigned char ReadDAC(unsigned char a);

#endif
