//**********************
// D-Amp header
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************

#ifndef __DAMP_H
#define __DAMP_H

//#define SCB_SYSAHBCLKCTRL                         (*((unsigned int *) (0x40048080)))    // System AHB clock control
#define SCB_SYSAHBCLKCTRL_GPIO                    ((unsigned int) 0x00000040) // Enables clock for GPIO

#define PORT0		0
#define PORT1		1
#define PORT2		2
#define PORT3		3

#define Damp_DB0I	(LPC_GPIO2->DATA&0x01)
#define Damp_DB1I	(LPC_GPIO2->DATA&0x02)
#define Damp_DB2I	(LPC_GPIO2->DATA&0x04)
#define Damp_DB3I	(LPC_GPIO2->DATA&0x08)
#define Damp_DB0_L	GPIOSetValue(PORT2, 0, OUTPUT_OFF)
#define Damp_DB0_H	GPIOSetValue(PORT2, 0, OUTPUT_ON)
#define Damp_DB1_L	GPIOSetValue(PORT2, 1, OUTPUT_OFF)
#define Damp_DB1_H	GPIOSetValue(PORT2, 1, OUTPUT_ON)
#define Damp_DB2_L	GPIOSetValue(PORT2, 2, OUTPUT_OFF)
#define Damp_DB2_H	GPIOSetValue(PORT2, 2, OUTPUT_ON)
#define Damp_DB3_L	GPIOSetValue(PORT2, 3, OUTPUT_OFF)
#define Damp_DB3_H	GPIOSetValue(PORT2, 3, OUTPUT_ON)
#define Damp_STATUS_L	GPIOSetValue(PORT3, 3, OUTPUT_OFF)
#define Damp_STATUS_H	GPIOSetValue(PORT3, 3, OUTPUT_ON)
#define Damp_POWER_L	GPIOSetValue(PORT0, 1, OUTPUT_OFF)
#define Damp_POWER_H	GPIOSetValue(PORT0, 1, OUTPUT_ON)

#define	Damp_DB0_IN	GPIOSetDir(PORT2,0, 0)
#define	Damp_DB1_IN	GPIOSetDir(PORT2,1, 0)
#define	Damp_DB2_IN	GPIOSetDir(PORT2,2, 0)
#define	Damp_DB3_IN	GPIOSetDir(PORT2,3, 0)
#define	Damp_DB0_OUT	GPIOSetDir(PORT2,0, 1)
#define	Damp_DB1_OUT	GPIOSetDir(PORT2,1, 1)
#define	Damp_DB2_OUT	GPIOSetDir(PORT2,2, 1)
#define	Damp_DB3_OUT	GPIOSetDir(PORT2,3, 1)
#define	Damp_STATUS_OUT	GPIOSetDir(PORT3,3, 1)
#define	Damp_POWER_OUT	GPIOSetDir(PORT0,1, 1)


extern volatile unsigned char VIRTUAL_flag;
extern volatile unsigned char POWER_flag;
extern volatile unsigned char CSD_L_flag;
extern volatile unsigned char CSD_R_flag;
extern volatile unsigned char SELECT_flag;
extern volatile unsigned char AMP_flag;
extern volatile unsigned char USB_POWER_status;
extern volatile unsigned char STANDBY_status;
extern volatile unsigned char CSD_L_status;
extern volatile unsigned char CSD_R_status;

// normal
#define CSD_OFF	0	// Amp off
#define CSD_ON	1	// Amp on
// reverse
//#define CSD_OFF	1	// Amp off
//#define CSD_ON	0	// Amp on

void InitDamp();
void GetDamp_Status();
void SetDamp_Status();
void DampPower();
void Select();
void ScanDamp();
void Phones();
void PrintSpeaker();

#endif

