//**********************
// FPGA header
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************

#ifndef __FPGA_H
#define __FPGA_H

#define FPGA_ADDR	0xD6	// 0x6B=01101011

//#define SCB_SYSAHBCLKCTRL                         (*((unsigned int *) (0x40048080)))    // System AHB clock control
#define SCB_SYSAHBCLKCTRL_GPIO                    ((unsigned int) 0x00000040) // Enables clock for GPIO

#define PORT0		0
#define PORT1		1
#define PORT2		2
#define PORT3		3

#define FPGA_INT	(LPC_GPIO1->DATA&0x200)
#define FPGA_DIN	(LPC_GPIO2->DATA&0x200)
#define FPGA_CCLK_L	GPIOSetValue(PORT1,10, OUTPUT_OFF)
#define FPGA_CCLK_H	GPIOSetValue(PORT1,10, OUTPUT_ON)
#define FPGA_MOSI_L	GPIOSetValue(PORT2,10, OUTPUT_OFF)
#define FPGA_MOSI_H	GPIOSetValue(PORT2,10, OUTPUT_ON)
#define FPGA_CSO_B_L	GPIOSetValue(PORT0, 7, OUTPUT_OFF)
#define FPGA_CSO_B_H	GPIOSetValue(PORT0, 7, OUTPUT_ON)
#define FPGA_PRG_B_L	GPIOSetValue(PORT3, 2, OUTPUT_OFF)
#define FPGA_PRG_B_H	GPIOSetValue(PORT3, 2, OUTPUT_ON)

#define	FPGA_INT_IN	GPIOSetDir(PORT1,9, 0)
#define	FPGA_CCLK_OUT	GPIOSetDir(PORT1,10, 1)
#define	FPGA_MOSI_OUT	GPIOSetDir(PORT2,10, 1)
#define	FPGA_DIN_IN	GPIOSetDir(PORT2,9, 0)
#define	FPGA_CSO_B_OUT	GPIOSetDir(PORT0,7, 1)
#define	FPGA_PRG_B_OUT	GPIOSetDir(PORT3,2, 1)

extern volatile unsigned char FPGA_status;
extern volatile unsigned char FPGA_fs;

void InitFPGA();
void GetFPGA_Status();
void GetFPGA_fs();
void PrintFPGA_Status();
void PrintFPGA_fs();
void ScanFPGA();
unsigned char GetAK4118(unsigned char a);
void PutAK4118(unsigned char a, unsigned char d);

#endif

