//**********************
// OLED header
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************

#ifndef __OLED_H
#define __OLED_H

#define PORT0		0
#define PORT1		1
#define PORT2		2
#define PORT3		3

#define OLED_CS_L	GPIOSetValue(PORT0, 8, OUTPUT_OFF)
#define OLED_CS_H	GPIOSetValue(PORT0, 8, OUTPUT_ON)
#define OLED_RES_L	GPIOSetValue(PORT1, 6, OUTPUT_OFF)
#define OLED_RES_H	GPIOSetValue(PORT1, 6, OUTPUT_ON)
#define OLED_DC_L	GPIOSetValue(PORT1, 7, OUTPUT_OFF)
#define OLED_DC_H	GPIOSetValue(PORT1, 7, OUTPUT_ON)
#define OLED_WR_L	GPIOSetValue(PORT2, 8, OUTPUT_OFF)
#define OLED_WR_H	GPIOSetValue(PORT2, 8, OUTPUT_ON)
#define OLED_RD_L	GPIOSetValue(PORT1, 8, OUTPUT_OFF)
#define OLED_RD_H	GPIOSetValue(PORT1, 8, OUTPUT_ON)
#define OLED_POWER_L	GPIOSetValue(PORT2, 11, OUTPUT_OFF)
#define OLED_POWER_H	GPIOSetValue(PORT2, 11, OUTPUT_ON)

#define	OLED_DB0_OUT	GPIOSetDir(PORT2,0, 1)
#define	OLED_DB1_OUT	GPIOSetDir(PORT2,1, 1)
#define	OLED_DB2_OUT	GPIOSetDir(PORT2,2, 1)
#define	OLED_DB3_OUT	GPIOSetDir(PORT2,3, 1)
#define	OLED_DB4_OUT	GPIOSetDir(PORT2,4, 1)
#define	OLED_DB5_OUT	GPIOSetDir(PORT2,5, 1)
#define	OLED_DB6_OUT	GPIOSetDir(PORT2,6, 1)
#define	OLED_DB7_OUT	GPIOSetDir(PORT2,7, 1)
#define	OLED_CS_OUT		GPIOSetDir(PORT0,8, 1)
#define	OLED_RES_OUT	GPIOSetDir(PORT1,6, 1)
#define	OLED_DC_OUT		GPIOSetDir(PORT1,7, 1)
#define	OLED_WR_OUT		GPIOSetDir(PORT2,8, 1)
#define	OLED_RD_OUT		GPIOSetDir(PORT1,8, 1)
#define	OLED_POWER_OUT	GPIOSetDir(PORT2,11, 1)


extern volatile unsigned char OLED_POWER_flag;

#define OLED_command	0
#define OLED_data		1
// BGR
#define BLACK	0x000000
#define GRAY	0x1F1F1F
#define SILVER	0x2F2F2F
#define WHITE	0x3F3F3F
#define RED		0x00003F
#define PURPLE	0x1F001F
#define GREEN	0x003F00
#define YELLOW	0x003F3F
#define BLUE	0x3F0000
#define CYAN	0x3F3F00
#define MAGENTA	0x3F003F
#define ORANGE	0x001F3F
#define NAVY	0x1F0000


void InitOLED();
void PowerOnOLED();
void PowerOffOLED();
void PowerOLED();
void SetFont(unsigned char x, unsigned char y, unsigned char a, unsigned int c, unsigned char f);
void PrintFont(unsigned char x, unsigned char y, char *a, unsigned int c, unsigned char f);
void SetFont2(unsigned char x, unsigned char y, unsigned char a, unsigned int c);
void PrintFont2(unsigned char x, unsigned char y, char *a, unsigned int c);
void LevelMeter(int u, int p, unsigned char LR);

#endif
