//**********************
// Timer32 header
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************

#ifndef __TIMER16_H__
#define __TIMER16_H__

#define CFG_CPU_CCLK                (48000000)
#define SCB_SYSAHBCLKDIV                          (*((unsigned int *) (0x40048078)))    // System AHB clock divider
#define SCB_SYSAHBCLKCTRL                         (*((unsigned int *) (0x40048080)))    // System AHB clock control
#define SCB_SYSAHBCLKCTRL_CT16B0                  ((unsigned int) 0x00000080) // Enables clock for 16-bit counter/timer 0
#define SCB_SYSAHBCLKCTRL_CT16B1                  ((unsigned int) 0x00000100) // Enables clock for 16-bit counter/timer 1

#define TMR_TMR16B0TC                             (*((unsigned int *) (0x4000C008)))    // Timer counter
#define TMR_TMR16B0IR                             (*((unsigned int *) (0x4000C000)))    // Interrupt register
#define TMR_TMR16B0TCR                            (*((unsigned int *) (0x4000C004)))    // Timer control register
#define TMR_TMR16B0MCR                            (*((unsigned int *) (0x4000C014)))    // Match control register
#define TMR_TMR16B0MR0                            (*((unsigned int *) (0x4000C018)))    // Match register 0
#define TMR_TMR16B1IR                             (*((unsigned int *) (0x40010000)))    // Interrupt register
#define TMR_TMR16B1TCR                            (*((unsigned int *) (0x40010004)))    // Timer control register
#define TMR_TMR16B1MCR                            (*((unsigned int *) (0x40010014)))    // Match control register
#define TMR_TMR16B1MR0                            (*((unsigned int *) (0x40010018)))    // Match register 0

#define TMR_TMR16B0IR_MR0                         ((unsigned int) 0x00000001)
#define TMR_TMR16B1IR_MR0                         ((unsigned int) 0x00000001)
#define TMR_TMR16B0TCR_COUNTERENABLE_ENABLED      ((unsigned int) 0x00000001)
#define TMR_TMR16B0TCR_COUNTERENABLE_DISABLED     ((unsigned int) 0x00000000)
#define TMR_TMR16B0TCR_COUNTERRESET_ENABLED       ((unsigned int) 0x00000002)
#define TMR_TMR16B1TCR_COUNTERENABLE_ENABLED      ((unsigned int) 0x00000001)
#define TMR_TMR16B1TCR_COUNTERENABLE_DISABLED     ((unsigned int) 0x00000000)
#define TMR_TMR16B1TCR_COUNTERRESET_ENABLED       ((unsigned int) 0x00000002)

#define TMR_TMR16B0MCR_MR0_INT_ENABLED            ((unsigned int) 0x00000001)
#define TMR_TMR16B0MCR_MR0_RESET_ENABLED          ((unsigned int) 0x00000002)
#define TMR_TMR16B1MCR_MR0_INT_ENABLED            ((unsigned int) 0x00000001)
#define TMR_TMR16B1MCR_MR0_RESET_ENABLED          ((unsigned int) 0x00000002)

#define TIMER16_CCLK_100US      ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 10000)
#define TIMER16_CCLK_1MS        ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 1000)

void TIMER16_0_IRQHandler(void);
void TIMER16_1_IRQHandler(void);

extern volatile unsigned int timer16_0_counter;
extern volatile unsigned int timer16_1_counter;

void timer16Enable(unsigned char timerNum);
void timer16Disable(unsigned char timerNum);
void timer16Init(unsigned char timerNum, unsigned int timerInterval);
void WaitNms(unsigned int n);
void timer16Delay(unsigned char timerNum, unsigned int delay);

#endif

