//**********************
// Timer32 header
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************

#ifndef __TIMER32_H__
#define __TIMER32_H__

#define CFG_CPU_CCLK                (48000000)
#define SCB_SYSAHBCLKDIV                          (*((unsigned int *) (0x40048078)))    // System AHB clock divider
//#define SCB_SYSAHBCLKCTRL                         (*((unsigned int *) (0x40048080)))    // System AHB clock control
#define SCB_SYSAHBCLKCTRL_CT32B0                  ((unsigned int) 0x00000200) // Enables clock for 32-bit counter/timer 0
#define SCB_SYSAHBCLKCTRL_CT32B1                  ((unsigned int) 0x00000400) // Enables clock for 32-bit counter/timer 1

#define TMR_TMR32B0IR                             (*((unsigned int *) (0x40014000)))      // Interrupt register
#define TMR_TMR32B0TCR                            (*((unsigned int *) (0x40014004)))      // Timer control register
#define TMR_TMR32B0IR_MR0                         ((unsigned int) 0x00000001)
#define TMR_TMR32B1IR                             (*((unsigned int *) (0x40018000)))      // Interrupt register
#define TMR_TMR32B1TCR                            (*((unsigned int *) (0x40018004)))      // Timer control register
#define TMR_TMR32B1IR_MR0                         ((unsigned int) 0x00000001)
#define TMR_TMR32B0MCR                            (*((unsigned int *) (0x40014014)))      // Match control register
#define TMR_TMR32B0MR0                            (*((unsigned int *) (0x40014018)))      // Match register 0
#define TMR_TMR32B1MCR                            (*((unsigned int *) (0x40018014)))      // Match control register
#define TMR_TMR32B1MR0                            (*((unsigned int *) (0x40018018)))      // Match register 0

#define TMR_TMR32B0TCR_COUNTERENABLE_ENABLED      ((unsigned int) 0x00000001)
#define TMR_TMR32B0TCR_COUNTERENABLE_DISABLED     ((unsigned int) 0x00000000)
#define TMR_TMR32B0TCR_COUNTERRESET_ENABLED       ((unsigned int) 0x00000002)
#define TMR_TMR32B1TCR_COUNTERENABLE_ENABLED      ((unsigned int) 0x00000001)
#define TMR_TMR32B1TCR_COUNTERENABLE_DISABLED     ((unsigned int) 0x00000000)
#define TMR_TMR32B1TCR_COUNTERRESET_ENABLED       ((unsigned int) 0x00000002)

#define TMR_TMR32B0MCR_MR0_INT_ENABLED            ((unsigned int) 0x00000001)
#define TMR_TMR32B0MCR_MR0_RESET_ENABLED          ((unsigned int) 0x00000002)
#define TMR_TMR32B1MCR_MR0_INT_ENABLED            ((unsigned int) 0x00000001)
#define TMR_TMR32B1MCR_MR0_RESET_ENABLED          ((unsigned int) 0x00000002)

#define TIMER32_CCLK_1US        ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 1000000)
#define TIMER32_CCLK_10US       ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 100000)
#define TIMER32_CCLK_100US      ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 10000)
#define TIMER32_CCLK_1MS        ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 1000)
#define TIMER32_CCLK_10MS       ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 100)
#define TIMER32_CCLK_100MS      ((CFG_CPU_CCLK/SCB_SYSAHBCLKDIV) / 10)
#define TIMER32_CCLK_1S         (CFG_CPU_CCLK/SCB_SYSAHBCLKDIV)

void TIMER32_0_IRQHandler(void);
void TIMER32_1_IRQHandler(void);

extern volatile unsigned int timer32_0_counter;
extern volatile unsigned int timer32_1_counter;
extern volatile unsigned char TIMER_flag;


void Wait100ms(unsigned int n);
void timer32Delay(unsigned char timerNum, unsigned int delay);
void timer32Enable(unsigned char timerNum);
void timer32Disable(unsigned char timerNum);
void timer32Init(unsigned char timerNum, unsigned int timerInterval);

#endif
