//**********************
// Volume header
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************

#ifndef __VOLUME_H
#define __VOLUME_H

#define PORT0		0
#define PORT1		1
#define PORT2		2
#define PORT3		3

#define VOLUME_nCS_L	GPIOSetValue(PORT0, 2, OUTPUT_OFF)
#define VOLUME_nCS_H	GPIOSetValue(PORT0, 2, OUTPUT_ON)
#define VOLUME_SCLK_L	GPIOSetValue(PORT0, 10, OUTPUT_OFF)
#define VOLUME_SCLK_H	GPIOSetValue(PORT0, 10, OUTPUT_ON)
#define VOLUME_SDATAI_L	GPIOSetValue(PORT0, 9, OUTPUT_OFF)
#define VOLUME_SDATAI_H	GPIOSetValue(PORT0, 9, OUTPUT_ON)

#define	VOLUME_nCS_OUT	GPIOSetDir(PORT0,2, 1)
#define	VOLUME_SCLK_OUT	GPIOSetDir(PORT0,10, 1)
#define	VOLUME_SDATAI_OUT	GPIOSetDir(PORT0,9, 1)

// PORT0_10
#define IOCON_JTAG_TCK_PIO0_10                    (*((unsigned int *) (0x40044068)))
#define IOCON_JTAG_TCK_PIO0_10_FUNC_GPIO          ((unsigned int) 0x00000001)
#define IOCON_JTAG_TCK_PIO0_10_MODE_PULLUP        ((unsigned int) 0x00000010)


// CS3310
// data volume
// 0xff	+31.5
// 0xfe +31.0
// 0xc0 0
// 0x02	-95.0
// 0x01 -95.5
// 0x00 software mute
extern volatile unsigned char volume;
extern volatile unsigned char mute;

void InitVolume();
void WriteVolume(unsigned char r, unsigned char l);
void MuteVolume();
void UpVolume();
void DownVolume();
void PrintVolume();

#endif
