//**********************
// EEPROM control with I2C
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************
#include "i2c.h"
#include "EEPROM.h"
#include "timer16.h"

void InitEEPROM()
{

	/* Initialize I2C */
//	i2cInit( I2CMASTER );	// see InitFPGA

}

// a:0-0x1FFFF
void WriteEEPROM(unsigned int a, unsigned char d)
{
	unsigned char upper_bit;
	upper_bit = (a & 0x10000) ? 0x02 : 0x00;

	I2CWriteLength = 4;
	I2CReadLength = 0;
	I2CMasterBuffer[0] = EEPROM_ADDR|upper_bit;	// to write
	I2CMasterBuffer[1] = (a>>8)&0xff;	// high address
	I2CMasterBuffer[2] = a&0xff;		// low address
	I2CMasterBuffer[3] = d;				// data
	I2CEngine();

	//wait Twr=5ms
	WaitNms(5);

}


// a:0-0x1FFFF
unsigned char ReadEEPROM(unsigned int a)
{

	unsigned char d;
	unsigned char upper_bit;
	upper_bit = (a & 0x10000) ? 0x02 : 0x00;

	I2CWriteLength = 3;
	I2CReadLength = 1;
	I2CMasterBuffer[0] = EEPROM_ADDR|upper_bit;	// to write
	I2CMasterBuffer[1] = (a>>8)&0xff;	// high address
	I2CMasterBuffer[2] = a&0xff;		// low address
	I2CMasterBuffer[3] = EEPROM_ADDR|upper_bit|RD_BIT;		// to read
	I2CEngine();

	d = I2CSlaveBuffer[0];

	return d;

}
