//**********************
// Remote control with IR
//
// (C)Copyright 2012 All rights reserved by Y.Onodera
// http://einstlab.web.fc2.com
//**********************
#include "type.h"
#include "gpio.h"
#include "timer16.h"
#include "remocon.h"
#include "Damp.h"
#include "volume.h"
#include "OLED.h"

// CUSTOM0=0xC7
// CUSTOM1=0x38
// DATA0=
// DATA1=

volatile unsigned char CODE[4];	// CUSTOM0,CUSTOM1,DATA0,DATA1
volatile unsigned REMOCON_flag=0;

extern volatile unsigned char Buf[64];
extern volatile unsigned char flag;
extern volatile unsigned char dispatch_code;

void InitRemocon()
{

	/* Initialize port pins */
	Remocon_IN;		// set input

	// Timer16-0 with 0.1ms
	timer16Init(0, TIMER16_CCLK_100US);
	timer16Enable(0);
	// Timer16-1 with 1ms
	timer16Init(1, TIMER16_CCLK_1MS);
	timer16Enable(1);

}


// NEC format
// 1T=0.56ms
// 0=on 1T + off 1T
// 1=on 1T + off 3T
// reader=on 16T+ off 8T
// stop=on 1T

void ScanRemocon()
{

	unsigned int i;
	unsigned int j;
	unsigned int k;

	// start 16T x 0.56ms = 8.96ms
	if(Remocon_DAT==0)
	{
		REMOCON_flag=1;

		timer16_0_counter=0;
		while(Remocon_DAT==0 && timer16_0_counter<200);
		j=timer16_0_counter;

		// NEC format
		if(j>70)
		{

			CODE[0]=0;
			CODE[1]=0;
			CODE[2]=0;
			CODE[3]=0;
			timer16_0_counter=0;
			while(Remocon_DAT!=0 && timer16_0_counter<200);

			for(k=0;k<4;k++)
			{
				for(i=0;i<8;i++)
				{
					timer16_0_counter=0;
					while(Remocon_DAT==0 && timer16_0_counter<30);
					timer16_0_counter=0;
					while(Remocon_DAT!=0 && timer16_0_counter<30);
					j=timer16_0_counter;
					if(j>10)
					{
						// 3T=1
						CODE[k]>>=1;
						CODE[k]|=0x80;
					}else{
						// 1T=0
						CODE[k]>>=1;
					}
				}
			}

			if(CODE[1]==0xC7 && CODE[0]==0x38)
			{
				// debug
//				Buf[2]=CODE[2];	// KeyCode
//				Buf[1]=0;
//				Buf[0]=0x41;
//				flag=1;
				dispatch_code=CODE[2];
			}
		}

		REMOCON_flag=0;

	}

}
